git-mergetool--lib.sh 6.41 KB
Newer Older
1
#!/bin/sh
2 3 4 5 6 7 8 9 10 11
# git-mergetool--lib is a library for common merge tool functions
diff_mode() {
	test "$TOOL_MODE" = diff
}

merge_mode() {
	test "$TOOL_MODE" = merge
}

translate_merge_tool_path () {
12
	echo "$1"
13 14 15
}

check_unchanged () {
16 17
	if test "$MERGED" -nt "$BACKUP"
	then
18 19
		status=0
	else
20 21
		while true
		do
22 23
			echo "$MERGED seems unchanged."
			printf "Was the merge successful? [y/n] "
24
			read answer || return 1
25 26 27 28 29 30 31 32
			case "$answer" in
			y*|Y*) status=0; break ;;
			n*|N*) status=1; break ;;
			esac
		done
	fi
}

33 34 35 36 37 38 39 40 41
valid_tool_config () {
	if test -n "$(get_merge_tool_cmd "$1")"
	then
		return 0
	else
		return 1
	fi
}

42
valid_tool () {
43 44 45 46
	setup_tool "$1" || valid_tool_config "$1"
}

setup_tool () {
47
	case "$1" in
48 49
	vim*|gvim*)
		tool=vim
50 51
		;;
	*)
52
		tool="$1"
53 54
		;;
	esac
55 56 57 58 59 60
	mergetools="$(git --exec-path)/mergetools"

	# Load the default definitions
	. "$mergetools/defaults"
	if ! test -f "$mergetools/$tool"
	then
61 62 63 64 65
		# Use a special return code for this case since we want to
		# source "defaults" even when an explicit tool path is
		# configured since the user can use that to override the
		# default path in the scriptlet.
		return 2
66 67 68 69 70 71 72 73
	fi

	# Load the redefined functions
	. "$mergetools/$tool"

	if merge_mode && ! can_merge
	then
		echo "error: '$tool' can not be used to resolve merges" >&2
74
		return 1
75 76 77
	elif diff_mode && ! can_diff
	then
		echo "error: '$tool' can only be used to resolve merges" >&2
78
		return 1
79 80
	fi
	return 0
81 82 83
}

get_merge_tool_cmd () {
84
	# Prints the custom command for a merge tool
85
	merge_tool="$1"
86 87
	if diff_mode
	then
88
		echo "$(git config difftool.$merge_tool.cmd ||
89
			git config mergetool.$merge_tool.cmd)"
90 91 92
	else
		echo "$(git config mergetool.$merge_tool.cmd)"
	fi
93 94
}

95
# Entry point for running tools
96
run_merge_tool () {
97 98 99 100 101
	# If GIT_PREFIX is empty then we cannot use it in tools
	# that expect to be able to chdir() to its value.
	GIT_PREFIX=${GIT_PREFIX:-.}
	export GIT_PREFIX

102
	merge_tool_path="$(get_merge_tool_path "$1")" || exit
103 104 105
	base_present="$2"
	status=0

106 107
	# Bring tool-specific functions into scope
	setup_tool "$1"
108 109 110 111 112 113 114 115 116 117 118 119 120
	exitcode=$?
	case $exitcode in
	0)
		:
		;;
	2)
		# The configured tool is not a built-in tool.
		test -n "$merge_tool_path" || return 1
		;;
	*)
		return $exitcode
		;;
	esac
121 122 123

	if merge_mode
	then
124
		run_merge_cmd "$1"
125
	else
126
		run_diff_cmd "$1"
127
	fi
128 129 130
	return $status
}

131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166
# Run a either a configured or built-in diff tool
run_diff_cmd () {
	merge_tool_cmd="$(get_merge_tool_cmd "$1")"
	if test -n "$merge_tool_cmd"
	then
		( eval $merge_tool_cmd )
		status=$?
		return $status
	else
		diff_cmd "$1"
	fi
}

# Run a either a configured or built-in merge tool
run_merge_cmd () {
	merge_tool_cmd="$(get_merge_tool_cmd "$1")"
	if test -n "$merge_tool_cmd"
	then
		trust_exit_code="$(git config --bool \
			mergetool."$1".trustExitCode || echo false)"
		if test "$trust_exit_code" = "false"
		then
			touch "$BACKUP"
			( eval $merge_tool_cmd )
			status=$?
			check_unchanged
		else
			( eval $merge_tool_cmd )
			status=$?
		fi
		return $status
	else
		merge_cmd "$1"
	fi
}

167
list_merge_tool_candidates () {
168 169
	if merge_mode
	then
170 171 172 173
		tools="tortoisemerge"
	else
		tools="kompare"
	fi
174 175 176 177
	if test -n "$DISPLAY"
	then
		if test -n "$GNOME_DESKTOP_SESSION_ID"
		then
178 179 180 181
			tools="meld opendiff kdiff3 tkdiff xxdiff $tools"
		else
			tools="opendiff kdiff3 tkdiff xxdiff meld $tools"
		fi
182
		tools="$tools gvimdiff diffuse ecmerge p4merge araxis bc3 codecompare"
183
	fi
184 185
	case "${VISUAL:-$EDITOR}" in
	*vim*)
186
		tools="$tools vimdiff emerge"
187 188
		;;
	*)
189
		tools="$tools emerge vimdiff"
190 191
		;;
	esac
192 193
}

194 195 196
show_tool_help () {
	unavailable= available= LF='
'
197 198 199

	scriptlets="$(git --exec-path)"/mergetools
	for i in "$scriptlets"/*
200
	do
201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216
		. "$scriptlets"/defaults
		. "$i"

		tool="$(basename "$i")"
		if test "$tool" = "defaults"
		then
			continue
		elif merge_mode && ! can_merge
		then
			continue
		elif diff_mode && ! can_diff
		then
			continue
		fi

		merge_tool_path=$(translate_merge_tool_path "$tool")
217 218
		if type "$merge_tool_path" >/dev/null 2>&1
		then
219
			available="$available$tool$LF"
220
		else
221
			unavailable="$unavailable$tool$LF"
222 223
		fi
	done
224 225

	cmd_name=${TOOL_MODE}tool
226 227
	if test -n "$available"
	then
228
		echo "'git $cmd_name --tool=<tool>' may be set to one of the following:"
229 230
		echo "$available" | sort | sed -e 's/^/	/'
	else
231
		echo "No suitable tool for 'git $cmd_name --tool=<tool>' found."
232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247
	fi
	if test -n "$unavailable"
	then
		echo
		echo 'The following tools are valid, but not currently available:'
		echo "$unavailable" | sort | sed -e 's/^/	/'
	fi
	if test -n "$unavailable$available"
	then
		echo
		echo "Some of the tools listed above only work in a windowed"
		echo "environment. If run in a terminal-only session, they will fail."
	fi
	exit 0
}

248 249
guess_merge_tool () {
	list_merge_tool_candidates
250 251 252 253 254 255
	echo >&2 "merge tool candidates: $tools"

	# Loop over each candidate and stop when a valid merge tool is found.
	for i in $tools
	do
		merge_tool_path="$(translate_merge_tool_path "$i")"
256 257
		if type "$merge_tool_path" >/dev/null 2>&1
		then
258 259
			echo "$i"
			return 0
260 261 262
		fi
	done

263 264
	echo >&2 "No known merge resolution program available."
	return 1
265 266 267 268 269
}

get_configured_merge_tool () {
	# Diff mode first tries diff.tool and falls back to merge.tool.
	# Merge mode only checks merge.tool
270 271
	if diff_mode
	then
272 273 274
		merge_tool=$(git config diff.tool || git config merge.tool)
	else
		merge_tool=$(git config merge.tool)
275
	fi
276 277
	if test -n "$merge_tool" && ! valid_tool "$merge_tool"
	then
278 279 280 281
		echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
		echo >&2 "Resetting to default..."
		return 1
	fi
282
	echo "$merge_tool"
283 284 285 286
}

get_merge_tool_path () {
	# A merge tool has been set, so verify that it's valid.
287
	merge_tool="$1"
288 289
	if ! valid_tool "$merge_tool"
	then
290 291 292
		echo >&2 "Unknown merge tool $merge_tool"
		exit 1
	fi
293 294
	if diff_mode
	then
295
		merge_tool_path=$(git config difftool."$merge_tool".path ||
296
				  git config mergetool."$merge_tool".path)
297 298
	else
		merge_tool_path=$(git config mergetool."$merge_tool".path)
299
	fi
300 301
	if test -z "$merge_tool_path"
	then
302
		merge_tool_path="$(translate_merge_tool_path "$merge_tool")"
303
	fi
304
	if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
305 306
		! type "$merge_tool_path" >/dev/null 2>&1
	then
307
		echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
308
			 "'$merge_tool_path'"
309 310 311 312 313 314 315
		exit 1
	fi
	echo "$merge_tool_path"
}

get_merge_tool () {
	# Check if a merge tool has been configured
316
	merge_tool="$(get_configured_merge_tool)"
317
	# Try to guess an appropriate merge tool if no tool has been set.
318 319
	if test -z "$merge_tool"
	then
320
		merge_tool="$(guess_merge_tool)" || exit
321 322 323
	fi
	echo "$merge_tool"
}